Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.util
Interface MapIndex

All Known Implementing Classes:
  ConditionalIndex, SimpleMapIndex

      public interface MapIndex

MapIndex is used to correlate values stored in an indexed Map (or attributes of those values) to the corresponding keys in the indexed Map.

Author:
  cp/gg 2002.10.31

Field Summary
`static java.lang.Object` | `NO_VALUE` Constant used to indicate that the index does not contain requested value.

Method Summary
`void` | `delete(java.util.Map.Entry entry)` Update this index in response to a remove operation on a cache.
`java.lang.Object` | `get(java.lang.Object oKey)` Using the index information if possible, get the value associated with the specified key.
`java.util.Comparator` | `getComparator()` Get the Comparator used to sort the index.
`java.util.Map` | `getIndexContents()` Get the Map that contains the index contents.
`ValueExtractor` | `getValueExtractor()` Obtain the ValueExtractor object that the MapIndex uses to extract an indexable Object from a value stored in the indexed Map.
`void` | `insert(java.util.Map.Entry entry)` Update this index in response to a insert operation on a cache.
`boolean` | `isOrdered()` Determine if the MapIndex orders the contents of the indexed information.
`boolean` | `isPartial()` Determine if indexed information for any entry in the indexed Map has been excluded from this index.
`void` | `update(java.util.Map.Entry entry)` Update this index in response to an update operation on a cache.

Field Detail

### NO_VALUE

    static final java.lang.Object NO_VALUE

  Constant used to indicate that the index does not contain requested value.

Method Detail

### getValueExtractor

    ValueExtractor getValueExtractor()

  Obtain the ValueExtractor object that the MapIndex uses to extract an indexable Object from a value stored in the indexed Map. This property is never null.
  Returns:
    a ValueExtractor object, never null

### isOrdered

    boolean isOrdered()

  Determine if the MapIndex orders the contents of the indexed information. To determine in which way the contents are ordered, get the Comparator from the index contents SortedMap object.
  Returns:
    true if the index contents are ordered, false otherwise

### isPartial

    boolean isPartial()

  Determine if indexed information for any entry in the indexed Map has been excluded from this index. This information is used for `IndexAwareFilter` implementations to determine the most optimal way to apply the index.
  Returns:
    true if any entry of the indexed Map has been excluded from the index, false otherwise
  Since:
    Coherence 3.6

### getIndexContents

    java.util.Map getIndexContents()

  Get the Map that contains the index contents.

  The keys of the Map are the return values from the ValueExtractor operating against the indexed Map's values, and for each key, the corresponding value stored in the Map is a Set of keys to the indexed Map.

  If the MapIndex is known to be ordered, then the returned Map object will be an instance of `SortedMap`. The SortedMap may or may not have a `Comparator` object associated with it; see `SortedMap.comparator()`.

  A client should assume that the returned Map object is read-only and must not attempt to modify it.

  Returns:
    a Map (or a SortedMap) of the index contents

### get

    java.lang.Object get(java.lang.Object oKey)

  Using the index information if possible, get the value associated with the specified key. This is expected to be more efficient than using the ValueExtractor against an object containing the value, because the index should already have the necessary information at hand.
  Parameters:
    `oKey` - the key that specifies the object to extract the value from
  Returns:
    the value that would be extracted by this MapIndex's ValueExtractor from the object specified by the passed key; NO_VALUE if the index does not have the necessary information

### getComparator

    java.util.Comparator getComparator()

  Get the Comparator used to sort the index.
  Returns:
    the comparator
  Since:
    Coherence 3.5

### insert

    void insert(java.util.Map.Entry entry)

  Update this index in response to a insert operation on a cache.
  Parameters:
    `entry` - the entry representing the object being inserted
  Since:
    Coherence 3.5

### update

    void update(java.util.Map.Entry entry)

  Update this index in response to an update operation on a cache.
  Parameters:
    `entry` - the entry representing the object being updated
  Since:
    Coherence 3.5

### delete

    void delete(java.util.Map.Entry entry)

  Update this index in response to a remove operation on a cache.
  Parameters:
    `entry` - the entry representing the object being removed
  Since:
    Coherence 3.5

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.